//
// Cursor Editor 0.01q for Linux    Qt Widgetekkel
//

// ******* Headerfileok ***********

#include <stdlib.h>
#include <fcntl.h>
#include <math.h>

#include <qbttngrp.h>
#include <qpushbt.h>
#include <qpopmenu.h>
#include <qdialog.h>
#include <qdir.h>
#include <qpainter.h>
#include <qwidget.h>
#include <qmenubar.h>
#include <qpixmap.h>
#include <qscrbar.h>
#include <qmsgbox.h>
#include <qfiledlg.h>
#include <qframe.h>
#include <qapp.h>
#include <qcolor.h>
#include <qevent.h>
#include <qlined.h>
#include <qlabel.h>
#include <qtooltip.h>
#include <qbitmap.h>

#include "toolbar/bmphandler.h"
#include "toolbar/toolbar.h"
#include "toolbar/leftbutt.res"
#include "toolbar/standard.res"

#include "cred.bit"
#include "rotate.res"

//***** Bitmap Resources **************

#include "toolbar/rock50.h"

//***** Constant definitions **********

#define WinX 400
#define WinY 360

#define NumX 32
#define NumY 32

#define pSiz 8

#define xMaxX 32
#define xMaxY 32

#define tableX 40
#define tableY 26

//******* Globlis Tpusdeklarcik ********************

typedef struct TPoint
{
  int  x;
  int  y;
} TPoint;  

enum TDrwStyle
{ dwPoint  = 0x0, dwLine  = 0x1, dwSquare = 0x2,
  dwCircle = 0x3, dwFill  = 0x4, dwPaste  = 0x5 };

//****** Pascal szer String opertorok ********
//****** meg ami mg hinyzott a Pascalbl *****

int chpos(char a, char *s)
{
  int i;
  i=0;
  while( (s[i] != a) && (s[i] != '\0') ) { i++; }  
  if(i>strlen(s))
    return(0);
  else  
    return(i);
}

int rchpos(char a, char *s)
{
  int i;
  i=strlen(s);
  while( (s[i] != a) && (i>=0) ) { i--; }  
  if(i>strlen(s))
    return(0);
  else  
    return(i);
}

char *nevtoext(char *R, char *s, char *x)
{
  char T[256];
  int  i;
  strcpy(T,s);
  i=rchpos('.',s);
  if(i==0)
    {
      strcat(T,".");
      strcat(T,x);
    }  
  return strcpy(R,T);
}

int hxToDec(char *s)
{
  char Hx[17] = "0123456789abcdef";
  int i;
  i  = chpos(tolower(s[0]), Hx) * 16;
  i += chpos(tolower(s[1]), Hx);
  return i;
}

/* int hxToDec(char *s)
{
  int i;
  sscanf(s,"%x",&i);
  return i;
}*/

char *strsub(char *R, char *s, int f, int l)
{
  char T[256];
  int  i;
  for (i = 0; i < l; i++)
    T[i] = s[i + f];
  T[i] = '\0';
  return strcpy(R,T);
}

char *readln(FILE *f,char *R)
{
  char T[256];
  char *t;
  fgets(T, 256, f);
  t = strchr(T, '\n');
    if (t != NULL)
        *t = 0;
  return strcpy(R,T);
}

int rnd( int max )
{
  return( int( drand48()*max));
}

//******* 1 bit/pix. Pattern Operators ********************

uchar getGndBit(uchar *xArr, int x, int y)
{
  uchar b;
  if((xArr[y * ((xMaxX / 8)) + (x / 8)] & (1 << (x % 8))) == 0)
    b=0;
  else
    b=1;
  return(b);    
}

void setGndBit(uchar *xArr, int x, int y, uchar b)
{
  if((b & 1) == 1)
    xArr[y*((xMaxX/8))+(x/8)]=xArr[y*((xMaxX/8))+(x/8)] | (1 << (x%8));
  else
    xArr[y*((xMaxX/8))+(x/8)]=xArr[y*((xMaxX/8))+(x/8)] & ( ~(1 << (x%8)));
}

void plotPoint(uchar *xArr, int x, int y, uchar pst)
{
  if( (x>=0 && y>=0) && (x<xMaxX && y<xMaxY) )
    setGndBit(xArr,x,y,pst);
}

char getPoint(uchar *xArr, int x, int y)
{
  if( (x>=0 && y>=0) && (x<xMaxX && y<xMaxY) )
    return(getGndBit(xArr,x,y));
  else  
    return(-1);   
}

void LineBetw(uchar *xArr, int x1, int y1, int x2, int y2, uchar pst)
{
  int x,y,z,a,b,dx,dy,d,deltap,deltaq;
  
  dx=abs(x2-x1);
  dy=abs(y2-y1);
  
  if(dy<=dx)
    {
      x=x1; y=y1; z=x2;
      if(x1<=x2)
        a=1;
      else
        a=-1;
          
      if(y1<=y2)
        b=1;
      else
        b=-1;  
      deltap=dy+dy;
      d=deltap-dx;
      deltaq=d-dx;
      plotPoint(xArr,x,y,pst);
      while(x!=z)
        {
          x=x+a;
          if(d<0)
            d=d+deltap;
          else
            {
              y=y+b;
              d=d+deltaq;
            }
          plotPoint(xArr,x,y,pst);
        }
    }
  else
    {
      x=x1; y=y1; z=y2;
      if(y1<=y2)
        a=1;
      else
        a=-1;
          
      if(x1<=x2)
        b=1;
      else
        b=-1;  
      deltap=dx+dx;
      d=deltap-dy;
      deltaq=d-dy;
      plotPoint(xArr,x,y,pst);
      while(y!=z)
        {
          y=y+a;
          if(d<0)
            d=d+deltap;
          else
            {
              x=x+b;
              d=d+deltaq;
            }
          plotPoint(xArr,x,y,pst);
        }
    }  
}

void DrawBox(uchar *xArr, int x1, int y1, int x2, int y2, uchar pst)
{
   LineBetw(xArr,x1,y1,x2,y1,pst);
   LineBetw(xArr,x2,y1,x2,y2,pst);
   LineBetw(xArr,x2,y2,x1,y2,pst);  
   LineBetw(xArr,x1,y2,x1,y1,pst);
}

double Deg2Rad(long ff)
{
  return (ff * M_PI / 180);
}

void DrawCirc(uchar *xArr, int xx1, int yy1, int xx2, int yy2, uchar pst)
{
  long r, f, dx, dy, px1, px2, py1, py2;

  dx = labs(xx1 - xx2);
  dy = labs(yy1 - yy2);
  r = (long)floor(sqrt((double)(dx * dx + dy * dy)) + 0.5);
  for (f = 1; f <= 180; f++) {
    px1 = (long)floor(r * cos(Deg2Rad(f * 2 - 2)) + 0.5);
    py1 = (long)floor(r * sin(Deg2Rad(f * 2 - 2)) + 0.5);
    px2 = (long)floor(r * cos(Deg2Rad(f * 2)) + 0.5);
    py2 = (long)floor(r * sin(Deg2Rad(f * 2)) + 0.5);
    LineBetw(xArr, xx1 + px1, yy1 + py1, xx1 + px2, yy1 + py2, pst);
  }
}

//******* Objektumdefincik *******************

#ifndef __INPUTBOX_H__
#define __INPUTBOX_H__
class InputBox : public QDialog
{
    Q_OBJECT;
public:
    QLineEdit* aLine;
    InputBox(QWidget* parent = NULL, const char* name = NULL);
};
#endif

#ifndef __QNLABEL_H__
#define __QNLABEL_H__
class QNLabel : public QLabel
{
    Q_OBJECT
public:
    QNLabel( QWidget *parent=0, const char *name=0, WFlags f=0 );
    int idNum;
protected:
    virtual void mousePressEvent( QMouseEvent *m );    
signals:
    void         Lclicked( int );
    void         Rclicked( int );
};
#endif

#ifndef __CURSORED_H__
#define __CURSORED_H__
class QCursorEd : public QFrame
{
    Q_OBJECT
public:
    uchar    *mbArr,*mmArr;
    
    bool      pushed;
    uchar     lcolor,rcolor,color,fcolor;
    
    TPoint    spot;
    TPoint    prevPos;
    TDrwStyle func;

    QCursorEd( QWidget *parent=0, int ww=1, int hh=1, 
               uchar *bArr=NULL, uchar *mArr=NULL  );

    void     setFunc(TDrwStyle v);

    void     reDraw();
    void     reSizeGrid(int x, int y);
    void     reSizeBox(int x, int y);
    
    void     reMoveBox(int x, int y);
    void     reMoveBoxX(int x);
    void     reMoveBoxY(int y);
    
protected:
    uchar    Point(int x, int y);
    void     FloodFill(int xx, int yy, int colr);
    
    void     paintEvent( QPaintEvent * );
    void     mousePressEvent( QMouseEvent * );
    void     mouseMoveEvent( QMouseEvent * );
    void     mouseReleaseEvent( QMouseEvent * );

private:
    int      FillCnt;
    int      W,H;
    int      sizX,sizY;
    int      posX,posY;
    
    QBrush   b0( 0x0040c040 );  // Transparency
    QBrush   b1( 0x00ffffff );  // Mask & Body
    QBrush   b2( 0x00402020 );  // Mask
    QBrush   h0( 0x00f040f0 );  // HotSpot

signals:
    void     CursorMove( int , int );
    void     It_Done();
};
#endif // __CURSORED_H__

//********* Ablak Alapobjektum ***************

#ifndef __CURSORALAP_H__
#define __CURSORALAP_H__
class CrsEdMain : public NWidget
{
    Q_OBJECT
public:

    int        isPreload = FALSE;
    int        pNullX=10;
    int        pNullY=10;

    int        pattX=320;
    int        pattY=320;

    uchar      bits[32*32/8 + 1];
    uchar      mask[32*32/8 + 1];
    
    uchar      Ubits[5,32*32/8 + 1];
    uchar      Umask[5,32*32/8 + 1];
    TPoint     Uspot[5];    
    int        UndoLevel;
    
    char       crsname[256];
    char       fname[256];
    
    int        xS,yS;

    CrsEdMain( QWidget *parent=0, const char *name=0 );

    void	init_data();
    void	loadcrs(char *fn);
    void        savecrs(char *fn);

public slots:

    void	q_open();
    void        q_import();
    void	q_save();
    void	q_saveas();
    void	q_new();
    void	q_quit();
    
    void	q_undo();
    void	done();
    
    void	q_redo();

    void        q_rename();
    void        q_clear();
   
    void	q_about();

    void        q_rotUp();
    void        q_rotDown();
    void        q_rotLeft();
    void        q_rotRight();
    
    void        getLcolor(int v);
    void        getRcolor(int v);
    void        setSampleCursor();    
    void        cursorMoved( int x, int y);
    void        Functions(int);
    
protected:
    void	resizeEvent( QResizeEvent * );

private:
    int         LToolNum;
    QIDButton   *idb[5];
    
    QToolBar    *Tool;
    
    QLabel      *lBox, *rBox, *testBox, *label;
    QNLabel     *cBoxT,*cBoxM, *cBoxB, *cBoxI;
    QMenuBar	*menu;
    QCursorEd   *pbit;
};
#endif // __ALAP_H__

//**** Objektumok ************************************

//**** QNumLabel *************************************

QNLabel::QNLabel( QWidget *parent, const char *name, WFlags f )
        :QLabel(parent,name,f)
{
   setBackgroundColor(white);
   setFrameStyle(Panel | Raised);
   setLineWidth(1);
}

void QNLabel::mousePressEvent( QMouseEvent *m )
{
   if( m->button() == LeftButton )
     emit Lclicked( idNum );
   else if( m->button() == RightButton )
     emit Rclicked( idNum );
}

//**** InputBox   ************************************

InputBox::InputBox(QWidget* parent, const char* name)
         :QDialog( parent, name, TRUE )
{
	aLine = new QLineEdit( this );
	aLine->setGeometry( 10, 10, 165, 25 );
	aLine->setText( "" );
        connect( aLine, SIGNAL(returnPressed()), SLOT(accept()) );

	QPushButton *OkButton,*CancButton;
	OkButton = new QPushButton( this );
	OkButton->setGeometry( 10, 40, 70, 25 );
	OkButton->setText( "O&k" );
        connect( OkButton, SIGNAL(clicked()), SLOT(accept()) );

	CancButton = new QPushButton( this );
	CancButton->setGeometry( 85, 40, 90, 25 );
	CancButton->setText( "&Cancel" );
        connect( CancButton, SIGNAL(clicked()), SLOT(reject()) );

	parent->resize( 185, 75 );
        aLine->setFocus();
}

//**** QCursorEd   ************************************

QCursorEd::QCursorEd( QWidget *parent=0, int ww=1, int hh=1, 
                      uchar *bArr=NULL, uchar *mArr=NULL  )
    : QFrame( parent )
{
  mbArr=bArr;
  mmArr=mArr;

  W=ww; H=hh;
  
  sizX=7; sizY=7;
  posX=0; posY=0;
  
  lcolor=1; rcolor=0; color=1; fcolor=0;
  
  prevPos.x=-1;   prevPos.y=-1;
  spot.x=-1; spot.y=-1;
  
  func=dwPoint;
  
  resize(W*sizX+1,H*sizY+1);
  move(1,1);  
  setFrameStyle( Box | Plain );
  setLineWidth( 1 );
  setMouseTracking(TRUE);
}

void QCursorEd::setFunc(TDrwStyle v)
{
   func=v;
}

void QCursorEd::reSizeGrid(int x, int y)
{
  sizX=x; sizY=y;
  resize(W*sizX+1,H*sizY+1);
}

void QCursorEd::reSizeBox(int x, int y)
{
  W=x; H=y;
  resize(W*sizX+1,H*sizY+1);  
}

void QCursorEd::reMoveBox(int x, int y)
{
  posX=x; posY=y;
  if(posX>xMaxX-W)
    posX=xMaxX-W;
  if(posY>xMaxY-H)
    posY=xMaxY-H;
  reDraw();
}

void QCursorEd::reMoveBoxX(int x)
{
  posX=x;
  if(posX>xMaxX-W)
    posX=xMaxX-W;
  reDraw();
}

void QCursorEd::reMoveBoxY(int y)
{
  posY=y;
  if(posY>xMaxY-H)
    posY=xMaxY-H;
  reDraw();
}

void QCursorEd::reDraw()
{
  int i,j;
  QPainter p;
 
  p.begin( this );
  for( j = 0; j <= H-1; j++ )
    {
      for ( i = 0; i <= W-1; i++ )
	{
	  if(getGndBit(mbArr,posX+i,posY+j)==1 &&
             getGndBit(mmArr,posX+i,posY+j)==1)
            p.setBrush(b2);
          else if(getGndBit(mbArr,posX+i,posY+j)==0 &&
                  getGndBit(mmArr,posX+i,posY+j)==1)
            p.setBrush(b1);
          else  
            p.setBrush(b0);
          if(i==spot.x && j==spot.y)  
            p.setBrush(h0);
          p.drawRect(i*sizX,j*sizY,sizX+1,sizY+1);
        }
    }
  p.end(); 
}

void QCursorEd::paintEvent( QPaintEvent *e )
{
  reDraw();
}

uchar QCursorEd::Point(int x, int y)
{
  uchar ki;
  ki=getGndBit(mmArr,x,y)+getGndBit(mbArr,x,y);
  return(ki);
}

void QCursorEd::FloodFill(int xx, int yy, int colr)
{
  FillCnt++;
  if(FillCnt<3072 && xx>=0 && yy>=0 && xx<xMaxX && yy<xMaxY)
    if( Point(xx,yy) == fcolor )
      {
         switch( colr )
           {
             case 0:
               plotPoint(mbArr,xx,yy,0);
               plotPoint(mmArr,xx,yy,0);
             break;
             case 1:
               plotPoint(mbArr,xx,yy,0);
               plotPoint(mmArr,xx,yy,1);
             break;
             case 2:
               plotPoint(mbArr,xx,yy,1);
               plotPoint(mmArr,xx,yy,1);
             break;
           } 
         FloodFill(xx,yy-1,colr);
         FloodFill(xx,yy+1,colr);
         FloodFill(xx-1,yy,colr);
         FloodFill(xx+1,yy,colr);
      }
}

void QCursorEd::mousePressEvent( QMouseEvent *e )
{
  int i,j,x,y;
  if(e->button()==LeftButton || e->button()==RightButton)
    {
      emit It_Done();
      x=e->x()/sizX;
      y=e->y()/sizY;
      
      if(y<0) y=0;
      if(y>xMaxY) y=xMaxY;  
  
      if(x<0) x=0;
      if(x>xMaxX) x=xMaxX;  
      
      if(e->button()==LeftButton)
        color=lcolor;
      else if(e->button()==RightButton)
        color=rcolor;
      
      if(e->state() == ControlButton)
        {  
           spot.x=x+posX;
           spot.y=y+posY;
           reDraw();
        }
      else  
        switch( func )
          {
            case dwFill:
              FillCnt=0;
              fcolor=Point(posX+x,posY+y);
              FloodFill(posX+x,posY+y,color);
              reDraw();     
            break; 
            case dwPoint:
            case dwLine:
            case dwSquare:
            case dwCircle:
              pushed=TRUE;
            break;  
            default: {}
          }  
      prevPos.x=x+posX;
      prevPos.y=y+posY;
    }  
}

void QCursorEd::mouseMoveEvent( QMouseEvent *e )
{
  int i,j,x,y;
  x=e->x()/sizX;
  y=e->y()/sizY;
  
  if( (prevPos.x != x+posX) && (prevPos.y != y+posY) )
    emit CursorMove(x+posX,y+posY);
  
  if(pushed && (e->state()==LeftButton || e->state()==RightButton))
    {
      if(e->state()==LeftButton)
        color=lcolor;
      else if(e->state()==RightButton)
        color=rcolor;

      if(y<0) y=0;
      if(y>xMaxY) y=xMaxY;  
  
      if(x<0) x=0;
      if(x>xMaxX) x=xMaxX;  

      if(func == dwPoint)
        {      
          prevPos.x=x+posX;
          prevPos.y=y+posY;
      
          switch( color )
            {
               case 0: 
                  setGndBit(mbArr,posX+x,posY+y,0);
                  setGndBit(mmArr,posX+x,posY+y,0);
               break;  
               case 1: 
                  setGndBit(mbArr,posX+x,posY+y,0);
                  setGndBit(mmArr,posX+x,posY+y,1);
               break;  
               case 2: 
                  setGndBit(mbArr,posX+x,posY+y,1);
                  setGndBit(mmArr,posX+x,posY+y,1);
               break;
               default: {}
           }    
         reDraw();  
       }
    } 
}

void QCursorEd::mouseReleaseEvent( QMouseEvent *e )
{
  int i,j,x,y;
  QString z;
  if( pushed )
    {
      pushed=FALSE;
      
      if(e->state()==LeftButton)
        color=lcolor;
      else if(e->state()==RightButton)
        color=rcolor;
      
      x=e->x()/sizX;
      y=e->y()/sizY;

      if(y<0) y=0;
      if(y>xMaxY) y=xMaxY;  
  
      if(x<0) x=0;
      if(x>xMaxX) x=xMaxX;  
      
      if(x+posX == prevPos.x && y+posY == prevPos.y)
         switch( color )
          {
             case 0: 
                setGndBit(mbArr,posX+x,posY+y,0);
                setGndBit(mmArr,posX+x,posY+y,0);
             break;  
             case 1: 
                setGndBit(mbArr,posX+x,posY+y,0);
                setGndBit(mmArr,posX+x,posY+y,1);
             break;  
             case 2: 
                setGndBit(mbArr,posX+x,posY+y,1);
                setGndBit(mmArr,posX+x,posY+y,1);
             break;
             default: {}
          }    
      else
        switch( func )
          {
             case dwPoint:      
               switch( color )
                 {
                    case 0: 
                       setGndBit(mbArr,posX+x,posY+y,0);
                       setGndBit(mmArr,posX+x,posY+y,0);
                    break;  
                    case 1: 
                       setGndBit(mbArr,posX+x,posY+y,0);
                       setGndBit(mmArr,posX+x,posY+y,1);
                    break;  
                    case 2: 
                       setGndBit(mbArr,posX+x,posY+y,1);
                       setGndBit(mmArr,posX+x,posY+y,1);
                    break;
                    default: {}
                 }    
             break;
             case dwLine:      
               switch( color )
                 {
                    case 0: 
                      LineBetw(mbArr,prevPos.x,prevPos.y,x+posX,y+posY,0);
                      LineBetw(mmArr,prevPos.x,prevPos.y,x+posX,y+posY,0);
                    break;  
                    case 1: 
                      LineBetw(mbArr,prevPos.x,prevPos.y,x+posX,y+posY,0);
                      LineBetw(mmArr,prevPos.x,prevPos.y,x+posX,y+posY,1);
                    break;  
                    case 2: 
                      LineBetw(mbArr,prevPos.x,prevPos.y,x+posX,y+posY,1);
                      LineBetw(mmArr,prevPos.x,prevPos.y,x+posX,y+posY,1);
                    break;
                   default: {}
                 }    
             break;
             case dwSquare:      
               switch( color )
                 {
                    case 0: 
                      DrawBox(mbArr,prevPos.x,prevPos.y,x+posX,y+posY,0);
                      DrawBox(mmArr,prevPos.x,prevPos.y,x+posX,y+posY,0);
                    break;  
                    case 1: 
                      DrawBox(mbArr,prevPos.x,prevPos.y,x+posX,y+posY,0);
                      DrawBox(mmArr,prevPos.x,prevPos.y,x+posX,y+posY,1);
                    break;  
                    case 2: 
                      DrawBox(mbArr,prevPos.x,prevPos.y,x+posX,y+posY,1);
                      DrawBox(mmArr,prevPos.x,prevPos.y,x+posX,y+posY,1);
                    break;
                   default: {}
                 }    
             break;  
             case dwCircle:      
               switch( color )
                 {
                    case 0: 
                      DrawCirc(mbArr,prevPos.x,prevPos.y,x+posX,y+posY,0);
                      DrawCirc(mmArr,prevPos.x,prevPos.y,x+posX,y+posY,0);
                    break;  
                    case 1: 
                      DrawCirc(mbArr,prevPos.x,prevPos.y,x+posX,y+posY,0);
                      DrawCirc(mmArr,prevPos.x,prevPos.y,x+posX,y+posY,1);
                    break;  
                    case 2: 
                      DrawCirc(mbArr,prevPos.x,prevPos.y,x+posX,y+posY,1);
                      DrawCirc(mmArr,prevPos.x,prevPos.y,x+posX,y+posY,1);
                    break;
                   default: {}
                 }    
             break;
          }
       reDraw();   
    }
}

//**** CrsEdMain   ************************************

CrsEdMain::CrsEdMain( QWidget *parent, const char *name )
    : NWidget( parent, name )
{
    int i,j,k;

    TGombRekord Gombok[] =
    { {T1016,SLOT(  q_quit()) ,6 ,"Exit"},

      {T1001,SLOT(  q_new())  ,0 ,"File New"},
      {T1002,SLOT(  q_open()) ,0 ,"File Open"},
      {T1003,SLOT(  q_save()) ,6 ,"File Save"},
      
      {T1009,SLOT(  q_undo()) ,0 ,"Edit Undo"},
      {T1010,SLOT(  q_clear()),6 ,"Edit Clear"},
      
      {bmRotUp  , SLOT( q_rotUp())   ,0 ,"Rotate Up"},
      {bmRotDown, SLOT( q_rotDown()) ,0 ,"Rotate Down"},
      {bmRotLeft, SLOT( q_rotLeft()) ,0 ,"Rotate Left"},
      {bmRotRight,SLOT( q_rotRight()),6 ,"Rotate Right"},

      {T1013,SLOT(  q_about()),0 ,"Help About"} };


//***** Alap menstruktra

    QPopupMenu *file = new QPopupMenu;
    CHECK_PTR( file );
    file->insertItem( "&New",        this, SLOT(q_new()) );
    file->insertItem( "&Open...",    this, SLOT(q_open()) );
    file->insertItem( "&Save",       this, SLOT(q_save()) );
    file->insertItem( "Save &As...", this, SLOT(q_saveas()) );
    file->insertSeparator();
    file->insertItem( "&Import...",  this, SLOT(q_import()) );
    file->insertSeparator();
    file->insertItem( "E&xit",       this, SLOT(q_quit()) );

    QPopupMenu *edit = new QPopupMenu;
    CHECK_PTR( edit );
    edit->insertItem( "&Undo", this, SLOT(q_undo()) );

    QPopupMenu *cursor = new QPopupMenu;
    CHECK_PTR( cursor );
    cursor->insertItem( "&Rename...",this, SLOT(q_rename()) );
    cursor->insertItem( "&Clear",this,     SLOT(q_clear()) );
    
    QPopupMenu *help = new QPopupMenu;
    CHECK_PTR( help );
    help->insertItem( "&About...", this, SLOT(q_about()) );

    menu = new QMenuBar( this );
    CHECK_PTR( menu );
    menu->insertItem( "&File",   file );
    menu->insertItem( "&Edit",   edit );
    menu->insertItem( "&Cursor", cursor );
    menu->insertItem( "&Help",   help );

    Tool = new QToolBar(this, 11, Gombok);
    Tool->setBaseYPoint(menu->height());

//***** Vltozk s adatterletek

    TGomb1Rekord Muvelet[]=
    { {PPOINT ,GPOINT ,"\0",0},
      {PLINE  ,GLINE  ,"\0",0},
      {PSQUAR ,GSQUAR ,"\0",0},
      {PCIRCL ,GCIRCL ,"\0",0},
      {PFILL  ,GFILL  ,"\0",0}
    };

    init_data();
    
    xS=7; yS=7;
    
    UndoLevel=0;

//***** Widgetek 

    label = new QLabel( this );
    label -> setFrameStyle(QFrame::Box | QFrame::Sunken);
    label -> setLineWidth(1);

    LToolNum=0;

    for(i=0;i<=4;i++)
      {
        idb[i] = new QIDButton(this, i, Muvelet[i].Bit1Tomb,
        Muvelet[i].Bit2Tomb);
        idb[i]->move(0,menu->height()+27+i*32);
        connect(idb[i], SIGNAL(clicked( int )), SLOT( Functions(int) ));
      }
    idb[LToolNum]->setState(1);  

    pbit = new QCursorEd( this, pattX/10, pattY/10, bits, mask );
    pbit->move(45,68);
    pbit->reSizeGrid(8,8);
    connect(pbit,SIGNAL(CursorMove(int,int)),SLOT(cursorMoved(int,int)));
    connect(pbit,SIGNAL(It_Done()),SLOT(done()));
    
    lBox = new QLabel( this );
    lBox -> setGeometry( WinX-90,68, 40, 20);
    lBox -> setFrameStyle(QFrame::Panel | QFrame::Raised);
    lBox -> setLineWidth(2);
    lBox -> setBackgroundColor(0x00ffffff);
    lBox -> setText("L");
    
    rBox = new QLabel( this );
    rBox -> setGeometry( WinX-50,68, 40, 20);
    rBox -> setFrameStyle(QFrame::Panel | QFrame::Raised);
    rBox -> setLineWidth(2);
    rBox -> setBackgroundColor(0x0040c040);
    rBox -> setText("R");
    
    cBoxT = new QNLabel( this );
    cBoxT -> setGeometry( WinX-90,92, 27, 20);
    cBoxT -> setBackgroundColor(0x0040c040);
    cBoxT->idNum=0;
    connect(cBoxT,SIGNAL(Lclicked( int )),SLOT(getLcolor(int)));
    connect(cBoxT,SIGNAL(Rclicked( int )),SLOT(getRcolor(int)));
    
    cBoxM = new QNLabel( this );
    cBoxM -> setGeometry( WinX-63,92, 26, 20);
    cBoxM -> setBackgroundColor( 0x00ffffff );
    cBoxM->idNum=1;
    connect(cBoxM,SIGNAL(Lclicked( int )),SLOT(getLcolor(int)));
    connect(cBoxM,SIGNAL(Rclicked( int )),SLOT(getRcolor(int)));
    
    cBoxB = new QNLabel( this );
    cBoxB -> setGeometry( WinX-37,92, 27, 20);
    cBoxB -> setBackgroundColor( 0x00402020 );
    cBoxB->idNum=2;
    connect(cBoxB,SIGNAL(Lclicked( int )),SLOT(getLcolor(int)));
    connect(cBoxB,SIGNAL(Rclicked( int )),SLOT(getRcolor(int)));

    QPushButton *testButt;    
    testButt = new QPushButton("Test",this);
    testButt -> setGeometry( WinX-90,122, 80, 20);
    connect(testButt,SIGNAL(clicked()),SLOT(setSampleCursor()));

    testBox = new QLabel( this );
    testBox -> setGeometry( WinX-90, 152, 80, 120);
    testBox -> setFrameStyle(QFrame::Box | QFrame::Sunken);
    testBox -> setLineWidth(1);
    testBox -> setBackgroundColor(0x00b0c0d0);
    testBox -> setText("Test Area");

//***** Ablak belltsok

    setMinimumSize( WinX, WinY );
//    done();

    QPixmap icon;
    icon.loadFromData((unsigned char *) &icCrEd,bitmapSize(icCrEd));
    icon.setMask( icon.createHeuristicMask() );
    setIcon(icon);
    setIconText("CursorEd");
}

void CrsEdMain::init_data()
{
  int i;
  QString s;
  for(i=0; i<=32*32/8; i++)
    bits[i]=0;
    
  for(i=0; i<=32*32/8; i++)
    mask[i]=0;
  
  pbit->spot.x=-1;  
  pbit->spot.y=-1;  
    
  strcpy(fname,"");
  strcpy(crsname,"");
  
  s.sprintf("CursorEd - [%s]",crsname);
  setCaption(s);
}

// ******* F objektumok ***********

void CrsEdMain::q_quit()
{
   if(isPreload && QMessageBox::query("Question","Do you want to save file?"))
     q_save();
   qApp->quit();  
}

void CrsEdMain::q_import()
// Import Windows 3.1 Cursor files
{
  char c,d,e;
  int i,j,k,l,LL,idx;
  char r[257];
  uchar buff[128];
  unsigned short w;
  QString z;
  FILE *be;

  QString s( QFileDialog::getOpenFileName(".","*.cur") );
  if ( ! s.isNull() )
    {
      strcpy(r,s);
      nevtoext(r,r,"crs");
      strcpy(fname,r);
      be=fopen(r,"r");
      q_new();
      fread(bits,1,70,be);
      
      fread(bits,1,128,be);
      for(i=0;i<32; i++)
        for(j=0;j<4;j++)
          buff[i*4+(3-j)]=bits[i*4+j];
      for(i=0;i<32;i++)
        for(j=0;j<32;j++)
           setGndBit(bits,31-i,31-j,getGndBit(buff,i,j));
          
      fread(mask,1,128,be);
      for(i=0; i<128; i++)
        mask[i]=~mask[i];
      for(i=0;i<32; i++)
        for(j=0;j<4;j++)
          buff[i*4+(3-j)]=mask[i*4+j];
      for(i=0;i<32;i++)
        for(j=0;j<32;j++)
           setGndBit(mask,31-i,31-j,getGndBit(buff,i,j));
        
      fclose(be);
      pbit->reDraw();
    }
}

void CrsEdMain::q_open()
{
  char r[257];

  QString s( QFileDialog::getOpenFileName(".","*.crs") );
  if ( ! s.isNull() )
    {
      strcpy(r,s);
      loadcrs(r);
      pbit->reDraw();
    }
}

void CrsEdMain::loadcrs(char *fn)
{
  char c;
  int i,j,k,l,LL,idx;
  char r[257],cs[257];
  
  char s1[256], s2[256], s3[256], s4[256];
  char line[1024], hln[256], hb[256];
  unsigned short w;
  QString z;
  FILE *be;

  q_new();
  strcpy(r,fn);
  nevtoext(r,r,"crs");
  strcpy(fname,r);

  be=fopen(r,"r");
     
  readln(be,line);
  strsub(crsname,line,10,strlen(line)-10);
     
  readln(be,s1);
  readln(be,s2);
  readln(be,s3);
  readln(be,s4);
     
  i=strlen(crsname);
   
  sprintf(cs,"CursorEd - [%s]",crsname);
  setCaption(cs);
   
  strsub(s3,s3,10+i,strlen(s3)-10-i);
  strsub(s4,s4,10+i,strlen(s4)-10-i);
  
  pbit->spot.x=atoi(s3);
  pbit->spot.y=atoi(s4);

  readln(be,line);

  i = 0;
  while ( ! feof(be) ) 
    {
      readln(be,line);
      if(strlen(line)==0 || strncmp(line,"static unsigned",14)==0)
        break;
      strcpy(hln,line);
      strsub(hln,hln,3,strlen(hln)-3);
      while ( *hln != '\0' ) 
        {
          strsub(hb,  hln, 2, 2);
          strsub(hln,hln, 6, strlen(hln)-6);
          mask[i] = hxToDec(hb);
          i++;
        }
    }
  strcpy(line, " ");
  i = 0; 
  while ( *line != '\0' && (! feof(be)) ) 
    {
      readln(be,line);
      strcpy(hln,line);
      strsub(hln,hln,3,strlen(hln)-3);
      while ( *hln != '\0' ) 
        {
          strsub(hb,  hln, 2, 2);
          strsub(hln,hln, 6, strlen(hln)-6);
          bits[i] = hxToDec(hb);
          i++;
        }
    } 
  fclose(be);
}

void CrsEdMain::q_save()
{
   if( strlen(fname)!=0)
     savecrs(fname);
   else
     q_saveas();  
}

void CrsEdMain::savecrs(char *fn)
{
  char c;
  int i,j,k,l,LL;
  char r[257],cs[257];

  FILE *ki;

  strcpy(r,fn);
  nevtoext(r,r,"crs");
  ki=fopen(r,"w");
      
  fprintf(ki,"// CURSOR %s\n",crsname);
  fprintf(ki,"#define %s_width 32\n",crsname);
  fprintf(ki,"#define %s_height 32\n",crsname);
  fprintf(ki,"#define %s_x %i\n",crsname,pbit->spot.x);
  fprintf(ki,"#define %s_y %i\n",crsname,pbit->spot.y);
      
  fprintf(ki,"static unsigned char %s_m[] = {\n",crsname);
  for(i=0; i<=6; i++)
    {
      fprintf(ki,"   ",NULL);
      for(j=0; j<=15; j++)
        fprintf(ki,"0x%.2x, ",mask[i*16+j]);
      fprintf(ki,"\n",NULL);
    }
  fprintf(ki,"   ",NULL);
  for(j=0; j<=14; j++)
    fprintf(ki,"0x%.2x, ",mask[i*16+j]);
  fprintf(ki,"0x%.2x };\n",mask[i*16+j]);

  fprintf(ki,"static unsigned char %s_b[] = {\n",crsname);
  for(i=0; i<=6; i++)
    {
      fprintf(ki,"   ",NULL);
      for(j=0; j<=15; j++)
        fprintf(ki,"0x%.2x, ",bits[i*16+j]);
      fprintf(ki,"\n",NULL);
    }
  fprintf(ki,"   ",NULL);
  for(j=0; j<=14; j++)
    fprintf(ki,"0x%.2x, ",bits[i*16+j]);
  fprintf(ki,"0x%.2x };\n\n",bits[i*16+j]);
  fclose(ki);    
}

void CrsEdMain::q_saveas()
{
  char r[257];
  if( strlen(crsname) == 0)
    q_rename();
  QString s( QFileDialog::getSaveFileName(".","*.crs") );
  if ( ! s.isNull() )
    {
       strcpy(r,s);
       strcpy(fname,s);
       savecrs(r);
    }
}

void CrsEdMain::q_clear()
{
  int i;
  QString s;
  for(i=0; i<=32*32/8; i++)
    bits[i]=0;
    
  for(i=0; i<=32*32/8; i++)
    mask[i]=0;
  
  pbit->spot.x=-1;  
  pbit->spot.y=-1;  
    
  pbit->reDraw();  
}

void CrsEdMain::q_new()
{
  init_data();
  pbit->reDraw();  
}

void CrsEdMain::q_rename()
{
  QString s;
  char cs[257];
  if(strlen(crsname)==0)  
    s.sprintf("%s","cr");
  else
    s.sprintf("%s",crsname);
  InputBox d(this, "Rename cursor-array");
  d.aLine->setText(s);
  d.aLine->selectAll();
  if(d.exec())
    {
      s=d.aLine->text();
      strcpy(crsname,s);
      sprintf(cs,"CursorEd - [%s]",crsname);
      setCaption(cs);
    }
  else if(strlen(crsname)==0)
    strcpy(crsname,"cr_unnamed");
}

void CrsEdMain::q_undo()
{
  int i,j;
  if(UndoLevel>0)
    {
       for(j=0;j<128;j++) bits[j]=Ubits[UndoLevel,j];
       for(j=0;j<128;j++) mask[j]=Umask[UndoLevel,j];
       pbit->spot.x=Uspot[UndoLevel].x;
       pbit->spot.y=Uspot[UndoLevel].y;
       UndoLevel=UndoLevel-1; 
       if(UndoLevel<0)
         UndoLevel=0;
       pbit->reDraw();  
    }
}

void CrsEdMain::done()
{
  int i,j;
  UndoLevel=UndoLevel+1;
  if(UndoLevel>5)
     {
        UndoLevel=5;
        for(i=4;i>=1;i--)
          {
             for(j=0;j<128;j++) Ubits[i,j]=Ubits[i+1,j];
             for(j=0;j<128;j++) Umask[i,j]=Umask[i+1,j];
             Uspot[i]=Uspot[i+1];
          }
     }   
   
  for(j=0;j<128;j++) Ubits[UndoLevel,j]=bits[j];
  for(j=0;j<128;j++) Umask[UndoLevel,j]=mask[j];

  Uspot[UndoLevel].x=pbit->spot.x;
  Uspot[UndoLevel].y=pbit->spot.y;
}

void CrsEdMain::q_redo()
{
}

void CrsEdMain::q_about()
{
  QMessageBox::message( "About", 
  "Cursor Editor\nfor double .XPM files\n\nv 0.1 (beta)\n(c) 1997  by Zsolt Borka");
}

void CrsEdMain::q_rotUp()
{
   char  mdata[xMaxX+1],bdata[xMaxX+1];
   
   int i,j,x,y;
   for(i=0;i<xMaxX;i++)
     {
        mdata[i]=getPoint(mask,i,0);
        bdata[i]=getPoint(bits,i,0);
     }
   for(y=0;y<xMaxY-1;y++)
     for(x=0;x<xMaxX;x++)
       {
         plotPoint(mask,x,y,getPoint(mask,x,y+1));
         plotPoint(bits,x,y,getPoint(bits,x,y+1));
       }
   for(i=0;i<xMaxX;i++)
     {
       plotPoint(mask,i,xMaxY-1,mdata[i]);
       plotPoint(bits,i,xMaxY-1,bdata[i]);
     }
   pbit->reDraw();  
}
void CrsEdMain::q_rotDown()
{
   char  mdata[xMaxX+1],bdata[xMaxX+1];
   int i,j,x,y;
   for(i=0;i<xMaxX;i++)
     {
       mdata[i]=getPoint(mask,i,xMaxY-1);
       bdata[i]=getPoint(bits,i,xMaxY-1);
     }
   for(y=xMaxY-2;y>=0;y--)
     for(x=0;x<xMaxX;x++)
       {
         plotPoint(mask,x,y+1,getPoint(mask,x,y));
         plotPoint(bits,x,y+1,getPoint(bits,x,y));
       }
   for(i=0;i<xMaxX;i++)
     {
       plotPoint(mask,i,0,mdata[i]);
       plotPoint(bits,i,0,bdata[i]);
     }
   pbit->reDraw();  
}
void CrsEdMain::q_rotLeft()
{
   char  mdata[xMaxX+1],bdata[xMaxX+1];
   int x,y;
   for(y=0;y<xMaxY;y++)
     {
       mdata[y]=getPoint(mask,0,y);
       bdata[y]=getPoint(bits,0,y);
     }
   for(y=0;y<xMaxY;y++)
     for(x=0;x<xMaxX-1;x++)
       {
         plotPoint(mask,x,y,getPoint(mask,x+1,y));
         plotPoint(bits,x,y,getPoint(bits,x+1,y));
       }
   for(y=0;y<xMaxX;y++)
     {
       plotPoint(mask,xMaxX-1,y,mdata[y]);
       plotPoint(bits,xMaxX-1,y,bdata[y]);
     }
   pbit->reDraw();  
}
void CrsEdMain::q_rotRight()
{
   char  mdata[xMaxX+1],bdata[xMaxX+1];
   int i,j,x,y;
   for(i=0;i<xMaxY;i++)
     {
       mdata[i]=getPoint(mask,xMaxY-1,i);
       bdata[i]=getPoint(bits,xMaxY-1,i);
     }
   for(y=0;y<xMaxY;y++)
     for(x=xMaxX-2;x>=0;x--)
       {
         plotPoint(mask,x+1,y,getPoint(mask,x,y));
         plotPoint(bits,x+1,y,getPoint(bits,x,y));
       }
   for(i=0;i<xMaxY;i++)
     {
       plotPoint(mask,0,i,mdata[i]);
       plotPoint(bits,0,i,bdata[i]);
     }
   pbit->reDraw();  
}

void CrsEdMain::getLcolor(int v)
{
   pbit->lcolor=v;
   switch( v )
     {
       case 0:
         lBox -> setBackgroundColor(0x0040c040);
       break;
       case 1:
         lBox -> setBackgroundColor(0x00ffffff);
       break;
       case 2:
         lBox -> setBackgroundColor(0x00402020);
       break;
     }
}

void CrsEdMain::getRcolor(int v)
{
   pbit->rcolor=v;
   switch( v )
     {
       case 0:
         rBox -> setBackgroundColor(0x0040c040);
       break;
       case 1:
         rBox -> setBackgroundColor(0x00ffffff);
       break;
       case 2:
         rBox -> setBackgroundColor(0x00402020);
       break;
       case 3:
         rBox -> setBackgroundColor(0x0080b0d0);
       break;
     }
}

void CrsEdMain::setSampleCursor()
{
  int x,y;
  x=32; y=32;
  QBitmap cb( x, y,(uchar *) &bits, TRUE);
  QBitmap cm( x, y,(uchar *) &mask, TRUE);
  QCursor custom( cb, cm, pbit->spot.x, pbit->spot.y);
  testBox->setCursor( custom );
}

void CrsEdMain::cursorMoved(int x, int y)
{
   QString s;
   s.sprintf("x:%.2i - y:%.2i",x,y);
   label->setText(s);
}

void CrsEdMain::Functions(int v)
{
   int i;
   LToolNum=v;
   for(i=0; i<=4; i++)
     {
       if(i==v)
         idb[i]->setState(1);
       else  
         idb[i]->setState(0);
     }    
    pbit->setFunc((TDrwStyle) v);
}


// ******* zenetek ****************

void CrsEdMain::resizeEvent( QResizeEvent *e )
{
   NWidget::resizeEvent( e );

   label->setGeometry( 0, rect().bottom()-19, width(), 20 );
}

// ******* Fprogram ***************

#include "crsedit.moc"

int main( int argc, char ** argv )
{
    QApplication a( argc, argv );
    CrsEdMain m;

    if(argc>1)
      {
         m.isPreload=TRUE;
         m.loadcrs(argv[1]);
      }

    QPixmap pmap;
    pmap.loadFromData((unsigned char *) &rock50,bitmapSize(rock50));
    m.setBackgroundPixmap(pmap);
    
    a.setMainWidget( &m );
    m.show();
    return a.exec();
}
